{Copyright Francesco Savastano 1999-2000 all rights reserved}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, RXSpin,
  GR32, GR32_Image, GR32_Layers, GR32_LowLevel, GR32_Transforms, Numedit,
  ExtDlgs;

type
  TForm1 = class(TForm)
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    BitBtn2: TBitBtn;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    Ido: TLabel;
    RxSpinEdit1: TRxSpinEdit;
    RxSpinEdit2: TRxSpinEdit;
    ImgView: TImgView32;
    BitBtn4: TBitBtn;
    Nagyit: TRxSpinEdit;
    ComboBox2: TComboBox;
    Label3: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    BitBtn3: TBitBtn;
    ListBox1: TListBox;
    BitBtn5: TBitBtn;
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ImgViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure BitBtn4Click(Sender: TObject);
    procedure NagyitChange(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private declarations }
    procedure WndProc(var Msg: TMessage); override;
  public
    { Public declarations }
    Xup, Yup: integer;
    En: boolean;
  end;

var
  Form1: TForm1;

implementation
uses unitG32;
{$R *.DFM}

procedure TForm1.WndProc(var Msg: TMessage);
begin
  if En then
  begin
    if ListBox1.Items.Count>15 then ListBox1.Clear;
    ListBox1.Items.Add(format('%d %d %d',[Msg.Msg, Msg.WParam, Msg.LParam]));
  end;
  inherited;
end;


procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var bit: TBitmap32;
    ind, n: integer;
    MS: dword;
begin
  Xup:=X; Yup:=Y;
  MS:=GetTickCount;

  screen.cursor:=crhourglass;
  bit:=TBitmap32.Create;
  bit.assign(ImgView.bitmap);
  ind:=combobox1.itemindex;
  if ind<0 then
  ind:=0;
  n:=fill32(bit,x,y,colordialog1.color,bit.pixels[x,y],trackbar1.Position/100,ind,0.1,0.5);
  ImgView.bitmap:=bit;
  bit.free;
  screen.cursor:=crdefault;

  MS:=GetTickCount-MS;
  Ido.Caption:=format('Id: %d/%d',[MS, n]);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if colordialog1.execute then
    bitbtn1.Font.Color:=colordialog1.Color;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  if OpenPictureDialog1.execute then
  begin
    ImgView.bitmap.LoadFromFile(OpenPictureDialog1.filename);
//    ImgView.bitmap.pixelformat:=pf24bit;
  //  image1.Picture.Bitmap.Canvas.brush.color:=clyellow;
  //  image1.picture.bitmap.canvas.textout(0,0,'Copyright Francesco Savastano 1999-2000');
  end;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  if FileExists(OpenPictureDialog1.filename) then
    ImgView.bitmap.LoadFromFile(OpenPictureDialog1.filename);
end;

procedure TForm1.ImgViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
var bit: TBitmap32;
    Cbase, Cnew: TColor32;
    n, fp: longword;
    mask: tbool2darray;
    MS: dword;
begin
  Xup:=X; Yup:=Y;
  MS:=GetTickCount;

//  screen.cursor:=crhourglass;
  bit:=TBitmap32.Create;
  bit.assign(ImgView.bitmap);

  case ComboBox2.ItemIndex of
    0: begin
         Cnew:=Color32(colordialog1.color);
         Cbase:=ImgView.bitmap.pixels[x,y];
         n:=fill32(ImgView.bitmap, x,y,
                   Cnew, Cbase, trackbar1.Position/100,
                   ComboBox1.ItemIndex, 0.1, 0.5);
         MS:=GetTickCount-MS;
         Ido.Caption:=format('Id: %d  (%d)',[MS, n]);
       end;
    1: begin
         Cnew:=Color32(colordialog1.color);
         Cbase:=ImgView.bitmap.pixels[x,y];
         n:=magicwand32(ImgView.bitmap,x,y,
                        Cnew, Cbase,trackbar1.Position/100,true,fp);
//         showmagicwand32(ImgView.bitmap,Cnew,mask);
         MS:=GetTickCount-MS;
         Ido.Caption:=format('Id: %d  (%d / %d)',[MS, n, fp]);
       end;
  end;



//  ImgView.bitmap.Assign(bit);
  ImgView.Refresh;
  bit.free;
//  screen.cursor:=crdefault;

end;

procedure TForm1.NagyitChange(Sender: TObject);
begin
  ImgView.Scale:=Nagyit.Value;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Label3.Caption:=IntToStr(TrackBar1.Position);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex:=0;
  ComboBox2.ItemIndex:=0;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  En:=true;
end;

end.
